sview/statistics/views.py
import re

from flask import jsonify
from flask import render_template
from flask import Blueprint
from flask import redirect
from flask import request
from flask import session
from flask import url_for
from flask_breadcrumbs import default_breadcrumb_root, register_breadcrumb

from .tasks import ResourceError
from .tasks import get_resource
from .tasks import PERIODS, DEFAULT_PERIOD
from .tasks import KNOWN_PARAMS
from .tasks.task_helpers import base64_decode
from .tasks.task_helpers import is_ip
from .view_helpers import get_tokens_hash
from .view_helpers import endpoint_arguments_constructor

statistics = Blueprint("statistics", __name__)
default_breadcrumb_root(statistics, ".")

DEVICE_TOKEN_CHARS = "^[a-z0-9]*$"
DEVICE_TOKEN_LENGTH = 64


@statistics.route("/")
@register_breadcrumb(
    statistics,
    ".",
    "Threat Detection",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def dashboard():
    page_title = "Overview"
    resource_names = [
        "all_countries_by_incidents_list",
        "all_attackers_graph",
        "all_incidents_graph",
        "top_countries_by_incidents_list",
        "top_passwords_by_usages_list",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/dashboard.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/attackers/")
@register_breadcrumb(
    statistics,
    ".attacker",
    "Attackers",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def attackers():
    page_title = "Attackers"
    resource_names = [
        "all_countries_by_attackers_list",
        "all_attackers_graph",
        "top_countries_by_attackers_graph",
        "top_countries_by_attackers_list_long",
        "top_attackers_by_incidents_list_long",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/attackers.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/attackers/details/ip/<string:ip>")
@register_breadcrumb(
    statistics,
    ".attacker.ip",
    "Attacker Details",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def attacker_details(ip):
    page_title = "Attacker Details"
    resource_names = [
        "selected_attacker_incidents_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, ip=ip, period=DEFAULT_PERIOD))

    if not is_ip(ip):
        return "Not a valid IPv4 address", 400

    params = {
        "period": period,
        "ip": ip,
    }

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/attacker_details.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/passwords/")
@register_breadcrumb(
    statistics,
    ".passwords",
    "Passwords",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def passwords():
    page_title = "Passwords"
    resource_names = [
        "top_passwords_by_usages_graph",
        "top_passwords_by_usages_list_long",
        "top_usernames_by_usages_list_long",
        "top_combinations_by_usages_list_long",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/passwords.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/passwords/details/<string:encoded_password>")
@register_breadcrumb(
    statistics,
    ".passwords.details",
    "Password Details",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def password_details(encoded_password):
    page_title = "Password Details"
    password = base64_decode(encoded_password)
    if not password:
        return "Unable to decode password", 400

    resource_names = [
        "logins_of_password_by_usages_list",
        "selected_password_by_usages_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(
            url_for(
                request.endpoint,
                encoded_password=encoded_password,
                period=DEFAULT_PERIOD,
            )
        )

    params = {
        "period": period,
        "password": password,
    }

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/password_details.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/incidents/")
@register_breadcrumb(
    statistics,
    ".incidents",
    "Incidents",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def incidents():
    page_title = "Incidents"
    resource_names = [
        "all_countries_by_incidents_list",
        "all_incidents_graph",
        "top_countries_by_incidents_list",
        "top_incident_types_by_incidents_list",
        "top_countries_by_incidents_graph",
        "top_traps_by_incidents_graph",
        "top_actions_by_incidents_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/incidents.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/ports/")
@register_breadcrumb(
    statistics,
    ".ports",
    "Ports",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def ports():
    page_title = "Ports"
    resource_names = [
        "all_ports_by_scans_graph",
        "top_ports_by_scans_list_long",
        "top_ports_by_scans_graph",
    ]
    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(url_for(request.endpoint, period=DEFAULT_PERIOD))

    params = {"period": period}

    resources = {
        resource_name: get_resource(resource_name, params)
        for resource_name in resource_names
    }

    return render_template(
        "statistics/ports.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/devices/")
@register_breadcrumb(
    statistics,
    ".devices",
    "My Devices",
    endpoint_arguments_constructor=endpoint_arguments_constructor,
)
def devices():
    page_title = "My Devices"
    resource_names = [
        "my_all_incidents_graph",
        "my_top_traps_by_incidents_graph",
        "my_top_countries_by_incidents_graph",
    ]
    tokens_hash = get_tokens_hash(session.get("devices"))

    period = request.args.get("period")
    if period not in PERIODS:
        return redirect(
            url_for(request.endpoint, period=DEFAULT_PERIOD, token=tokens_hash)
        )

    if tokens_hash != request.args.get("token"):
        return redirect(url_for(request.endpoint, period=period, token=tokens_hash))

    params = (
        {"period": period, "token": tokens_hash} if tokens_hash else {"period": period}
    )

    tokens = tuple(session.get("devices", []))

    resources = {
        resource_name: get_resource(
            resource_name, {**params, "my_device_tokens": tokens}
        )
        for resource_name in resource_names
    }

    return render_template(
        "statistics/devices.html",
        resource_names=resource_names,
        periods=PERIODS,
        active_params=params,
        resources=resources,
        page_title=page_title,
    )


@statistics.route("/api/resource")
def get_resource_view():
    resource_name = request.args.get("name")
    if resource_name is None:
        return jsonify({"error": "No resource name provided."})

    params = {}
    for param_name, default_value in KNOWN_PARAMS.items():
        param = request.args.get(param_name, default_value)
        if param is not None:
            params[param_name] = param

    if "devices" in session:
        params["my_device_tokens"] = tuple(session["devices"])

    try:
        data = get_resource(resource_name, params)
    except ResourceError as exc:
        return jsonify({"error": str(exc)})

    response = jsonify(
        {
            "resource_name": resource_name,
            "data": data,
        }
    )

    if data is not None:

sview/templates/_macros.html
{%- macro nav_link(endpoint, text, target_blank=False, period_dependant=True, dropdown=True) -%}
	{%- if request.endpoint.split(".")[1] == endpoint.split(".")[1] %}
		{%- set active = " active" %}
	{%- elif endpoint.split(".")[1][:-1] in request.endpoint.split(".")[1] %}
		{%- set active = " active" %}
	{%- else %}
		{%- set active = "" %}
	{%- endif %}
{%- if dropdown %}
<a class="dropdown-item{{ active }}{% if period_dependant %} period_dependant_link{% endif %}"
            href={% if period_dependant and active_params is defined %}"{{ url_for(endpoint, period=active_params['period']) }}"{% else %}"{{ url_for(endpoint) }}"{% endif %}>
            {{ text }}
</a>
{%- else %}
<li class="nav-item">
    <a class="nav-link{{ active }}{% if period_dependant %} period_dependant_link{% endif %}"
            {%- if target_blank %}
            target="_blank"{%- endif %}
            href={% if period_dependant and active_params is defined %}"{{ url_for(endpoint, period=active_params['period']) }}"{% else %}"{{ url_for(endpoint) }}"{% endif %}>
            {{ text }}
            {%- if target_blank %}<sup><i class="fas fa-external-link-alt fa-xs ml-1"></i></sup>{%- endif %}
    </a>
</li>
{%- endif %}
{%- endmacro -%}

{%- macro common_form(form, target, submit_caption, file=False) -%}
<form method="post" action="{{ target }}" class="form-vertical"{% if file %} enctype="multipart/form-data"{% endif %}>
	{% for field in form %}
		{% if field.name == "csrf_token" -%}
		{{ field() }}
		{% elif field.type == "BooleanField" -%}
		<div class="form-group form-check">
			{{ field(class="form-check-input") }}
			{{ field.label(class="form-check-label") }}
		</div>
		{%- else -%}
		<div class="form-group">
			{{ field.label() }}
			{{ field(class="form-control") }}
		</div>
		{% endif -%}
	{% endfor %}
		<button type="submit" class="btn btn-primary btn-lg">
			{{ submit_caption }}
		</button>
</form>
{%- endmacro -%}

{%- macro nav_dropdown_item(name, items) -%}
<li class="nav-item dropdown">
	<a class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-expanded="false">
	{{ name }} </a>
	<div class="dropdown-menu">
		{% for navitem in items %}
		{{ navitem }}
		{% endfor -%}
	</div>
</li>
{%- endmacro -%}

{%- macro accordion_item(heading, content, meta_name, data_parent, collapsed=True) -%}
<div class="card">
	<div class="card-header" id="heading{{ meta_name }}">
		<h2 class="mb-0">
		<button class="btn btn-link btn-block text-left{% if collapsed %} collapsed{% endif %}" type="button" data-toggle="collapse" data-target="#collapse{{ meta_name }}" aria-expanded="true" aria-controls="collapseOne">
			{{ heading|safe }}
		</button>
		</h2>
	</div>
	<div id="collapse{{ meta_name }}" class="collapse{% if not collapsed %} show{% endif %}" aria-labelledby="heading{{ meta_name}}" data-parent="#{{ data_parent }}">
		<div class="card-body">
		{{ content|safe }}
		</div>
	</div>
</div>
{%- endmacro -%}

sview/templates/_snippets.html
{%- macro js_required() -%}
	<noscript>
		<div style="display:flex;height:70px;width:100%;align-items:center;justify-content:center">
			<strong>Javasript required to display this feature.</strong>
		</div>
	</noscript>
{%- endmacro -%}

{%- macro no_data_infobox(source) -%}
	<div style="display:flex;height:70px;width:100%;align-items:center;justify-content:center">
		<strong>
			{%- if source is none or source is undefined -%}
				{{ data_not_cached() }}
			{%- else -%}
				{{ empty_period() }}
			{%- endif -%}
		</strong>
	</div>
{%- endmacro -%}

{%- macro data_not_cached() -%}
	<noscript>
		{{ _("Data source is being cached. Try it later please.") }}
	</noscript>
{%- endmacro -%}

{%- macro empty_period() -%}
	{{ _("No data available from this period.") }}
{%- endmacro -%}

{%- macro data_item(data) -%}
	{%- set len_limit = 14 -%}
	{%- if data|length > len_limit -%}
	<abbr title="{{ data }}">
		{{ data | truncate(len_limit, True, "...", 0) }}
	</abbr>
	{%- else -%}
		{{ data }}
	{%- endif -%}
{%- endmacro -%}
{%- macro country_code_flag(cc) -%}
	<span class="fi fi-{{ cc|lower }}"></span>
{%- endmacro -%}

{%- macro country_code_item(data) -%}
	{{ country_code_flag(data) }}&nbsp;&nbsp;<abbr title="{{data|uncc}}">{{ data }}</abbr>
{%- endmacro -%}

{%- macro spinner_overlay(id) -%}
	<div id="{{ id }}" class="sview-overlay">
		<div class="w-100 d-flex justify-content-center align-items-center">
			<div class="sview-spinner"></div>
		</div>
	</div>
{%- endmacro -%}

{%- macro data_box(id, name, source, data_attr) -%}
	<div class="card mb-4 shadow-sm">
		<div class="card-body">
			<h5 class="card-title">{{ name }}</h5>
			{{ spinner_overlay("spinner-{}".format(id)) }}
			<div id="{{ id }}" class="table-responsive">
			{% if source %}
				<table class="table table-borderless table-sm table-hover mb-0">
				{% for item in source %}
					<tr>
						<td>{{ loop.index }}.</td>
						<td>
							<strong>
								{% if caller %}{{ caller(item[data_attr]) }}{% else %}{{ data_item(item[data_attr]) }}{% endif %}
							</strong>
						</td>
						<td>{{ item.count }}</td>
					</tr>
				{% endfor %}
				</table>
			{% else %}
				{{ no_data_infobox(source) }}
			{% endif %}
			</div>
		</div>
	</div>
{%- endmacro -%}

{%- macro pair_data_box(id, name, source, data_attr1, data_attr2) -%}
	<div class="card mb-4 shadow-sm">
		<div class="card-body">
			<h5 class="card-title">{{ name }}</h5>
			{{ spinner_overlay("spinner-{}".format(id)) }}
			<div id="{{ id }}" class="table-responsive">
				{% if source %}
					<table class="table table-borderless table-sm table-hover mb-0">
						{% for item in source %}
							<tr>
								<td>{{ loop.index }}.</td>
								<td>
									<strong>
										{{ data_item(item[data_attr1]) }}
									</strong>
								</td>
								<td>
									<strong>
										{{ data_item(item[data_attr2]) }}
									</strong>
								</td>
								<td>{{ item.count }}</td>
							</tr>
						{% endfor %}
					</table>
				{% else %}
					{{ no_data_infobox(source) }}
				{% endif %}
			</div>
		</div>
	</div>
{%- endmacro -%}

{%- macro map_box(id, name, source, label) -%}
	<div id="{{ id }}" class="js-required world-map" style="position: relative; width: 900; height: 300px;"></div>
		{{ spinner_overlay("spinner-{}".format(id)) }}
		{{ js_required() }}
		{% if source %}
			<script type="text/javascript">
				let scores = {{ source|tojson }};
				draw_map("#{{ id }}", scores, "{{ label }}");
			</script>
		{% else %}
			<script type="text/javascript">
				draw_map("#{{ id }}", {}, "{{ label }}");
			</script>
		{% endif %}
{%- endmacro -%}

{%- macro line_box(id, name, source, xkey, ykey, label) -%}
	<div class="card mb-4 shadow-sm">
		<div class="card-body">
			<h5 class="card-title">{{ name }}</h5>
			<div class="js-required">
				{{ spinner_overlay("spinner-{}".format(id)) }}
				<div id="{{ id }}">
					{% if source %}
						{{ morris_line(id, source, xkey, ykey, label) }}
					{% else %}
						{{ no_data_infobox(source) }}
					{% endif %}
				</div>
			</div>
			{{ js_required() }}
		</div>
	</div>
{%- endmacro -%}

{%- macro button_line_box(id, name, periods, params, source, xkey, ykey, label) -%}
	<div class="card mb-4 shadow-sm">
		<div class="card-body">
			<h5 class="card-title">{{ name }}</h5>
			<div class="js-required">
				{{ spinner_overlay("spinner-{}".format(id)) }}
				{{ graph_period_buttons(id, periods, params) }}
				<div id="{{ id }}">
					{% if source %}
						{{ morris_line(id, source, xkey, ykey, label) }}
					{% else %}
						{{ no_data_infobox(source) }}
					{% endif %}
			</div>
		</div>
	</div>
{%- endmacro -%}

{%- macro morris_line(id, source, xkey, ykey, label) -%}
	<script type="text/javascript">
		create_graph(
			'{{ id }}',
			'{{ xkey }}',
			{%- if ykey is string %}
				['{{ ykey }}'],
			{%- else %}
				{{ ykey|tojson }},
			{% endif %}
			{%- if label is string %}
				['{{ label }}'],
			{%- else %}
				{{ label|tojson }},
			{% endif %}
			{{ source|tojson }}
		);
	</script>
{%- endmacro -%}

{%- macro big_period_buttons(resource_names, periods, active_params) -%}
	<div class="col">
		<div class="btn-group-toggle pb-4 d-flex flex-row justify-content-center flex-wrap align-items-center" data-toggle="buttons">
{%		for period, period_params in periods.items() %}
				<label class="btn btn-outline-secondary btn js-required m-1" style="width: 150px;">
					<input type="radio" name="options" autocomplete="off"
{%					if period==active_params["period"] %}
							checked
{%					endif %}
						onclick='process_new_settings(
							"{{ url_for("statistics.get_resource_view") }}",
							{{ resource_names|tojson }},
							Object.assign(
								{{ active_params|tojson }},
								{"period": "{{ period }}"}  // Override active period passed via active params
							)
						)'
					>
					{{ period_params["label"] }}
				</label>
				<noscript>
{%				if period==active_params["period"] %}
						<a href="?period={{ period }}" class="btn btn-secondary" name="options" autocomplete="off">
{%				else %}
						<a href="?period={{ period }}" class="btn btn-outline-secondary" name="options" autocomplete="off">
{%				endif %}
					{{ period_params["label"] }}
					</a>
				</noscript>
{%		endfor %}
		</div>
	</div>
{%- endmacro -%}

{%- macro graph_period_buttons(resource_name, periods, active_params) -%}
			<div class="container">
				<div class="row justify-content-end">
					<div class="m-auto mr-md-4">
						<div class="btn-group btn-group-toggle" data-toggle="buttons">
{%					for period in periods %}
							<label class="btn btn-outline-secondary btn-sm">
								<input type="radio" name="options" autocomplete="off"
{%								if period==active_params["period"] %}
										checked
{%								endif %}
									onclick='process_new_settings(
										"{{ url_for("statistics.get_resource_view") }}",
										["{{ resource_name }}"],
										Object.assign(
											{{ active_params|tojson }},
											{"period": "{{ period }}"}  // Override active period passed via active params
										)
									)'
								> {{ period }}
							</label>
{%					endfor %}
						</div>
					</div>
				</div>
			</div>
{%- endmacro -%}

{%- macro request_missing_resources(resource_names, resources, params) -%}
	<script>
		request_missing_resources(
			{{ resource_names|tojson }},
			{{resources|tojson}},
			"{{ url_for("statistics.get_resource_view") }}",
			{{params|tojson}}
		)
	</script>
{%- endmacro -%}

sview/templates/layout.html
{%- from "_macros.html" import nav_link, nav_dropdown_item with context -%}
<!DOCTYPE html>
<html lang="en" class="h-100">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="fediverse:creator" content="@turris@fosstodon.org">

        <title>{% if page_title %}{{ page_title }} &verbar; {% endif %}Sentinel View</title>
        <link rel="me" href="https://fosstodon.org/@turris"/>
        <link rel="icon" type="image/svg+xml" href="{{ url_for("static", filename="favicon.svg") }}" />
        <link rel="icon" type="image/png" href="{{ url_for("static", filename="favicon.png") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/bootstrap.min.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/dark-mode.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/all.min.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="jvectormap/jquery-jvectormap.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/morris.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/flag-icon.min.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/fontawesome.min.css") }}" />
        <link type="text/css" rel="stylesheet" href="{{ url_for("static", filename="css/sview.css") | autoversion }}" />
        <script type="text/javascript" src="{{ url_for("static", filename="js/jquery.min.js") }}"></script>
        <script type="text/javascript" src="{{ url_for("static", filename="js/bootstrap.min.js") }}"></script>
        <script type="text/javascript" src="{{ url_for("static", filename="jvectormap/jquery-jvectormap.min.js") }}"></script>
        <script type="text/javascript" src="{{ url_for("static", filename="jvectormap/jquery-jvectormap-world-mill.js") }}"></script>
        <script type="text/javascript" src="{{ url_for("static", filename="js/raphael.min.js") }}"></script>
        <script type="text/javascript" src="{{ url_for("static", filename="js/morris.min.js") }}"></script>
        <script type="text/javascript" src="{{ url_for("static", filename="js/sview.js") | autoversion }}"></script>
        {% if dynfwhost %}
            <script type="text/javascript">
                let connection = {{ dynfwhost | safe }};
                let server = connection.server;
                let ws_port = connection.port;
            </script>
            <script type="text/javascript" src="{{ url_for("static", filename="js/dynfwviz.js") | autoversion }}"></script>
        {% endif %}
        <noscript>
            <style type="text/css">
                .js-required {
                    display: none;
                }
            </style>
        </noscript>
        <!-- Matomo -->
        <script>
            var _paq = window._paq = window._paq || [];
            /* tracker methods like "setCustomDimension" should be called before "trackPageView" */
            _paq.push(['trackPageView']);
            _paq.push(['enableLinkTracking']);
            (function () {
                var u = "https://matomo.nic.cz/";
                _paq.push(['setTrackerUrl', u + 'matomo.php']);
                _paq.push(['setSiteId', '71']);
                var d = document, g = d.createElement('script'), s = d.getElementsByTagName('script')[0];
                g.async = true; g.src = u + 'matomo.js'; s.parentNode.insertBefore(g, s);
            })();
        </script>
        <!-- End Matomo Code -->
    </head>
    <body class="d-flex flex-column h-100">
        <header>
            <nav class="navbar navbar-expand-lg navbar-dark bg-dark shadow-sm fixed-top">
                <div class="container">
                    <a class="navbar-brand" href="{{ url_for("statistics.dashboard") }}">
                        Sentinel View
                    </a>
                    <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#main-menu"
                        aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="main-menu">
                        <ul class="navbar-nav">
                            {{ nav_dropdown_item( _("Threat Detection"), [
                                nav_link("statistics.dashboard", _("Overview")),
                                nav_link("statistics.incidents", _("Incidents")),
                                nav_link("statistics.attackers", _("Attackers")),
                                nav_link("statistics.passwords", _("Passwords")),
                                nav_link("statistics.ports", _("Ports")),
                                nav_link("statistics.devices", _("My Devices")),
                            ]) }}
                            {{ nav_link("dynfw.index_dynfw", _("Dynamic Firewall"), period_dependant=False, dropdown=False) }}
                            {{ nav_dropdown_item( _("Password Checker"), [
                                nav_link("pcheck.index_pwned", _("Check Password"), period_dependant=False),
                                nav_link("pcheck.apiv1.info", _("API"), period_dependant=False)
                            ]) }}
                            {{ nav_link("web.greylist", _("Greylist"), target_blank=True, period_dependant=False, dropdown=False) }}
                            {{ nav_link("report.info", _("Reports"), period_dependant=False, dropdown=False) }}
                        </ul>
                        <div class="custom-control custom-switch ml-auto">
                            <input type="checkbox" class="custom-control-input" id="darkSwitch" />
                            <label class="custom-control-label text-light" for="darkSwitch">Dark mode</label>
                        </div>
                        <script type="text/javascript" src="{{ url_for("static", filename="js/dark-mode-switch.js") }}"></script>
                    </div>
                </div>
            </nav>
        </header>
        <main class="container">
            {%- with messages = get_flashed_messages(with_categories=True) %}
            {%- if messages %}
            {%- for category, message in messages %}
            <div class="alert alert-{{ category }} alert-dismissible fade show" role="alert">
                {{ message }}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            {%- endfor %}
            {%- endif %}
            {%- endwith %}
            <h1 class="mt-3 mb-2">{{page_title}}</h1>
            {%- if breadcrumbs|length > 1 %}
            <nav class="mb-4" aria-label="breadcrumb">
                <ol class="breadcrumb">
                    {%- for breadcrumb in breadcrumbs -%}
                    {%- if loop.last %}
                    <li class="breadcrumb-item active" aria-current="page">{{ breadcrumb.text }}</li>
                    {%- else %}
                    <li class="breadcrumb-item">
                        <a href="{{ breadcrumb.url }}">{{ breadcrumb.text }}</a>
                    </li>
                    {%- endif %}
                    {%- endfor -%}
                </ol>
            </nav>
            {%- endif %}
            {%- block body %}{% endblock %}
        </main>
        <footer class="footer mt-auto py-3">
            <div class="container">
                <p class="text-center">
                    <small class="text-muted">
                        <span xmlns:dct="https://purl.org/dc/terms/" property="dct:title">Turris Sentinel data</span> by <a
                            xmlns:cc="https://creativecommons.org/ns#" target="_blank" href="https://www.turris.cz" property="cc:attributionName"
                            rel="cc:attributionURL">TurrisTech</a> is licensed under a <a rel="license" target="_blank"
                            href="https://creativecommons.org/licenses/by-nc-sa/4.0/">Creative Commons
                            Attribution-NonCommercial-ShareAlike 4.0 International License</a>.
                        <br>
                        <a rel="license" target="_blank" href="https://creativecommons.org/licenses/by-nc-sa/4.0/">
                            <img
                                alt="Creative Commons License" style="border-width:0"
                                src="https://i.creativecommons.org/l/by-nc-sa/4.0/80x15.png"
                            />
                        </a>
                    </small>
                </p>
            </div>
        </footer>
        {%- block body_end %}{% endblock %}
        <button id="goTop"><i class="fas fa-chevron-up"></i></button>
        <script>basicScrollTop();</script>
    </body>
</html>